package gp_dbc.system;

import JinRyuu.JRMCore.JRMCoreH;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.PlayerEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.Main;
import gp_dbc.utils.PlayerUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;

import static gp_dbc.Main.gp;
import static gp_dbc.config.ConfigManager.*;
import static net.minecraft.util.StatCollector.translateToLocal;

public class TimeJail {

    int tick = 0;
    final int SLOWTICK_MAX = 20;//2000;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkTimeInmate(TickEvent.ServerTickEvent event) {
        if (tick >= SLOWTICK_MAX) {
            tick = 0;

            if (gp.jail.getInmates() == null)
                return;

            for (int i = 0; i < gp.jail.getInmates().size(); i++) {
                Inmate inmate = gp.jail.getInmates().get(i);

                if (System.currentTimeMillis() - inmate.getTimeStartJail() > inmate.getSecInJail() * 1000) {

                    // Connected
                    EntityPlayer player = PlayerUtils.getPlayerFromUUID(inmate.getUuid());
                    if (player == null)
                        gp.jail.removePlayerFromJail(MinecraftServer.getServer(), inmate.getUuid(), true);
                    else
                        gp.jail.removePlayerFromJail(MinecraftServer.getServer(), player, true);
                }
            }
        }
        else
            tick++;
    }

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkPlayerIsFree(PlayerEvent.PlayerLoggedInEvent event) {
        if (gp.jail.freePlayer(event.player))
            event.player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.out_of_jail")));

        Inmate inmate = gp.jail.getInmate(event.player.getUniqueID());
        if (inmate != null) {
            long time_left = (inmate.getSecInJail() * 1000 - (System.currentTimeMillis() - inmate.getTimeStartJail())) / 1000;
            String timeString = gp.jail.displayTimeInJail(time_left);

            if (!translateToLocal("msg.inmate_going_to_jail").isEmpty())
                event.player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("msg.inmate_going_to_jail") + timeString));
        }

    }
}
